Subject: Re: [PATCH] Disable TSO for non standard qdiscs

From: Stephen Hemminger <[email-masked]>
Date: Fri, 1 Feb 2008 09:24:39 -0800

On Fri, 1 Feb 2008 15:34:21 +0100
Andi Kleen <[email-masked]> wrote:

> > The TSO defer logic is based on your congestion window and current
> > window size.  So the actual frame sizes hitting your NIC attached to
> > your DSL probably aren't anywhere near 64KB, but probably more in line
> > with whatever your window size is for DSL.
> 
> DSL windows can be quite large because a lot of DSL lines have a quite
> long latency due to error correction. And with ADSL2 we have upto 16Mbit
> now.
> 
> > I think we're having more of a disagreement of what is considered the
> > "normal case" user.  If you are on a slow link, such as a DSL/cable
> > line, your TCP window/congestion window aren't going to be big enough to
> > generate large TSO's, so what is the issue?  But disabling TSO, say on a
> 
> 64k TSOs are likely even with DSL. Anyways even with smaller TSOs the
> change still makes sense because each increase makes packet scheduling
> less smooth.
> 
> -Andi

I wish there was a per-device setting for the max-size of TSO burst.

-- 
Stephen Hemminger <[email-masked]>